AppTitle "Hunt of the Dragon"

Graphics 320,200,0,CommandLine()

SetBuffer BackBuffer()

.start

ClsColor 0,150,0

Cls

Color 100,100,100
Text 90,2,"Hunt of the Dragon"
Color 0,0,255
Text 89,1,"Hunt of the Dragon"

Color 255,255,0

Text 90,28,"Geek Basic 2020"
Text 90,42,"By Gemino Smothers"

Text 1,70,"You're a hungry dragon!"
Text 1,84,"Eat all of the humans to grow in power."
Text 1,98,"If more than ten ecape your wrath,"
Text 1,112,"they will rise up and kill you."

Text 100,170,"Press any key..."

Flip

WaitKey()

grassimage=LoadImage("graphics/grass.png")
dragonheadimage=LoadImage("graphics/dragonhead.png")
humanimage=LoadAnimImage("graphics/human.png",10,10,0,8)

eatsound=LoadSound("sounds/eat.wav")
screamsound=LoadSound("sounds/scream.wav")
dragondeathsound=LoadSound("sounds/dragondeath.wav")

maxsize=2000

Dim sx(maxsize)
Dim sy(maxsize)

game=1
score=0
m=19
dir=2
spawntimer=MilliSecs()
spawntime=5000

For c=0 To m

	If c<=m Then

		sx(c)=150-c
		sy(c)=100

 Else

		sx(c)=0
		sy(c)=0

 End If

Next

Type humans

	Field x
	Field y
	Field f
	Field d
	Field s
	Field st	

End Type

Repeat

	Cls

	DrawImage grassimage,0,0

	If KeyHit(200) And dir<>3 Then dir=1
	If KeyHit(205) And dir<>4 Then dir=2
	If KeyHit(208) And dir<>1 Then dir=3
	If KeyHit(203) And dir<>2 Then dir=4
	If KeyHit(1) Then End
	
	For c=m To 1 Step-1

		sx(c)=sx(c-1)
		sy(c)=sy(c-1)
	
	Next

	Select dir
	
		Case 1
			sy(0)=sy(0)-1

		Case 2
			sx(0)=sx(0)+1

		Case 3
			sy(0)=sy(0)+1
		
		Case 4
			sx(0)=sx(0)-1

	End Select
	
	For c=1 To m

		If sx(0)=sx(c) And sy(0)=sy(c) Then

			game=0

		EndIf

	Next

	If sx(0)<=1 Or sx(0)>=320 Or sy(0)<=1 Or sy(0)>=200 Then game=0

	alt=False

	For c=0 To m

		alt=Not alt

		If c=0 Then

			If dir=1 Then DrawImage dragonheadimage,sx(c)-5,sy(c)-9
			If dir=2 Then DrawImage dragonheadimage,sx(c)-1,sy(c)-4
			If dir=3 Then DrawImage dragonheadimage,sx(c)-5,sy(c)-2
			If dir=4 Then DrawImage dragonheadimage,sx(c)-9,sy(c)-5
			
		ElseIf alt=True Then

			Color 255,0,0
			
			Plot sx(c),sy(c)

			If dir=2 Or dir=4 Then Plot sx(c),sy(c)+1
			If dir=1 Or dir=3 Then Plot sx(c)+1,sy(c)

		Else

			Color 100,0,0

			Plot sx(c),sy(c)
			Plot sx(c),sy(c)+1	


		EndIf
	
	Next

	If MilliSecs()>spawntimer+spawntime Then
	
		h.humans=New humans
		
		h\x=0
		h\y=Rand(10,180)
		h\f=0
		h\d=MilliSecs()

		If spawntime>2000 Then spawntime=spawntime-50
		spawntimer=MilliSecs()

	EndIf

	For h.humans=Each humans

		DrawImage humanimage,h\x,h\y,h\f

		If MilliSecs()>h\d+30 Then

			h\f=h\f+1
			h\x=h\x+1
			h\d=MilliSecs()

		EndIf

		If h\f>7 Then h\f=0		

		If h\x>320 Then
		
			escaped=escaped+1
			Delete h

		ElseIf RectsOverlap(sx(0),sy(0),10,10,h\x,h\y,10,10) Then

			PlaySound eatsound

			m=m+10
			score=score+1
			Delete h
			
		ElseIf RectsOverlap(sx(0),sy(0),10,10,h\x-30,h\y-30,50,50) And h\s=0 Then

			PlaySound screamsound
			h\s=1
			h\st=MilliSecs()

		ElseIf h\s And MilliSecs()>h\st+2000 Then
		
			h\s=0

		EndIf

	Next
	
	If escaped>=10 Then game=0
	
	Color 255,255,0
	Text 1,1,"Score: "+score+" Escaped: "+escaped

	Delay 2

	Flip

Until game=0

PlaySound dragondeathsound

Delay 1000

Cls
Color 255,255,0

Text 1,1,"You lose!"
Text 1,14,"Score: "+score

Flip

Delay 500

FlushKeys()
WaitKey()

Goto start